; *******************************************************
; *                                                     *
; *     Turbo Pascal Runtime Library Version 6.0        *
; *     CRT Interface Unit                              *
; *                                                     *
; *     Copyright (C) 1988,91 Borland International     *
; *                                                     *
; *******************************************************

        TITLE   CRT

        INCLUDE SE.ASM

; Coordinate record

X               EQU     (BYTE PTR 0)
Y               EQU     (BYTE PTR 1)

; BIOS workspace equates

CrtMode         EQU     (BYTE PTR 49H)
CrtWidth        EQU     (BYTE PTR 4AH)
Cursor          EQU     (WORD PTR 50H)
Addr6845        EQU     (WORD PTR 63H)
Timer           EQU     (DWORD PTR 6CH)
CrtInfo         EQU     (BYTE PTR 87H)
CrtRows         EQU     (BYTE PTR 84H)

DATA    SEGMENT WORD PUBLIC

; Externals

        EXTRN   CheckBreak:BYTE,CheckEOF:BYTE,DirectVideo:BYTE
        EXTRN   CheckSnow:BYTE,LastMode:WORD,TextAttr:BYTE
        EXTRN   WindMin:WORD,WindMax:WORD
        EXTRN   ScreenMode:Byte ; Actual screen mode (may be graphic)
        EXTRN   ScrollAttrTable : Byte; Table of scroll attrs for CGA modes
; Local workspace

DelayCnt        DW      ?
CurCrtSize      DW      ?
NormAttr        DB      ?
ScanCode        DB      ?
BreakFlag       DB      ?

DATA    ENDS
CODE    SEGMENT BYTE PUBLIC

        ASSUME  CS:CODE,DS:DATA

; Publics

        PUBLIC  Initialize,TextMode,Window,ClrScr,ClrEol,InsLine
        PUBLIC  DelLine,GotoXY,WhereX,WhereY,TextColor,TextBackground
        PUBLIC  LowVideo,HighVideo,NormVideo,Delay,Sound,NoSound
        PUBLIC  KeyPressed,ReadKey  ; AssignCRT Rewritten on pascal language
        PUBLIC  ReInitCrt,ReadKeyWord,Beep,GetPos,SetPos,WriteCh
        PUBLIC  EmulateCursor,ScrollUp,Fill,CRTReturn

; One-time initialization

Initialize:

        MOV     AH,0FH
        CALL    Video
        CMP     AL,7
        JE      @@1
        CMP     AL,3
        JBE     @@1
        MOV     AX,3
        CALL    CrtInit
@@1:    CALL    CrtSetup
        MOV     AH,8
        XOR     BH,BH
        CALL    Video
        MOV     AL,AH
        AND     AL,7FH
        MOV     NormAttr,AL
        MOV     TextAttr,AL
        XOR     AX,AX
        MOV     CheckEOF,AL
        MOV     ScanCode,AL
        MOV     BreakFlag,AL
        INC     AX
        MOV     CheckBreak,AL
        MOV     AX,40H
        MOV     ES,AX
        MOV     DI,OFFSET Timer
        MOV     AL,ES:[DI]
@@2:    CMP     AL,ES:[DI]
        JE      @@2
        MOV     AL,ES:[DI]
        MOV     CX,-1
        CALL    DelayLoop
        MOV     AX,55
        XCHG    AX,CX
        NOT     AX
        XOR     DX,DX
        DIV     CX
        MOV     DelayCnt,AX
        PUSH    DS
        PUSH    CS
        POP     DS
        MOV     DX,OFFSET CtrlBreak
        MOV     AX,dosSetInt*256+1BH
        INT     DOS
        POP     DS
        RET

; Initialize CRT
; In    AL = Requested mode
;       AH = Requested font

CrtInit:

        MOV     DX,40H
        MOV     ES,DX
        AND     ES:CrtInfo,0FEH
        CMP     AL,7
        JE      @@1
        CMP     AL,4
        JB      @@1
        MOV     AL,3
@@1:    PUSH    AX
        MOV     AH,0
        CALL    Video
        POP     AX
        OR      AH,AH
        JE      @@2
        MOV     AX,1112H
        MOV     BL,0
        CALL    Video
        MOV     AX,1130H
        MOV     BH,0
        MOV     DL,0
        CALL    Video
        CMP     DL,42
        JNE     @@2
        OR      ES:CrtInfo,1
        MOV     AX,100H
        MOV     CX,600H
        CALL    Video
        MOV     AH,12H
        MOV     BL,20H
        CALL    Video
@@2:    RET

; Setup CRT variables according to selected mode

CrtSetup:

        MOV     AH,0FH
        CALL    Video
        PUSH    AX
        MOV     AX,1130H
        MOV     BH,0
        MOV     DL,0
        CALL    Video
        POP     AX
        MOV     CL,0
        OR      DL,DL
        JNE     @@1
        MOV     DL,24
        CMP     AL,3
        JA      @@1
        MOV     CL,1
@@1:    MOV     DH,DL
        MOV     DL,AH
        DEC     DL
        MOV     AH,0
        CMP     DH,24
        JBE     @@2
        MOV     AH,1
@@2:    cmp     AL,3
        JBE     @@3
        CMP     AL,7
        JE      @@3
        JMP     SHORT  @@4
@@3:    MOV     LastMode,AX
@@4:    CMP     AL,10h
        JB      @@5
        MOV     DH,24
        JA      @@5
        MOV     DH,33
@@5:    MOV     ScreenMode,AL
        MOV     CurCrtSize,DX
        MOV     CheckSnow,CL
        Cmp     ScreenMode,7
        Jz      @@6
        Cmp     ScreenMode,3
        JBE     @@6
        Mov     DirectVideo,0
        JMP  Short @@7
@@6:    MOV     DirectVideo,1
@@7:    XOR     AX,AX
        MOV     WindMin,AX
        MOV     WindMax,DX
        RET

; Ctrl-Break interrupt handler

CtrlBreak:

        PUSH    AX
        PUSH    DS
        MOV     AX,SEG DATA
        MOV     DS,AX
        CMP     CheckBreak,0
        JE      @@1
        MOV     BreakFlag,1
@@1:    POP     DS
        POP     AX
        IRET

; Check for Ctrl-Break

BreakCheck:

        CMP     BreakFlag,0
        JNE     @@1
        RET
@@1:    MOV     BreakFlag,0
@@2:    MOV     AH,1
        INT     16H
        JE      @@3
        MOV     AH,0
        INT     16H
        JMP     @@2
@@3:    MOV     AL,'^'
        CALL    WriteChar
        MOV     AL,'C'
        CALL    WriteChar
        CALL    WriteCrLf
        INT     23H

; Set CRT text mode

TextMode:

        MOV     BX,SP
        MOV     AX,SS:[BX+4]
        CALL    CrtInit
        CALL    CrtSetup
        MOV     AL,NormAttr
        MOV     TextAttr,AL
        RETF    2

; Define output window

Window:

        MOV     BX,SP
        MOV     DL,SS:[BX+10]
        MOV     DH,SS:[BX+8]
        MOV     CL,SS:[BX+6]
        MOV     CH,SS:[BX+4]
        CMP     DL,CL
        JA      @@1
        CMP     DH,CH
        JA      @@1
        DEC     DL
        JS      @@1
        DEC     DH
        JS      @@1
        DEC     CL
        CMP     CL,CurCrtSize.X
        JA      @@1
        DEC     CH
        CMP     CH,CurCrtSize.Y
        JA      @@1
        MOV     WindMin,DX
        MOV     WindMax,CX
        CALL    SetCursor
@@1:    RETF    8

; Clear screen

ClrScr:
        Cmp     ScreenMode,7
        JA     @@1
        CALL    ScrollAttr
        MOV     BH,AL
        MOV     AX,6*256
        MOV     CX,WindMin
        MOV     DX,WindMax
        CALL    Video
        MOV     DX,WindMin
        CALL    SetCursor
        RETF
        ;EGA,VGA grahic mode
        ;Calculate symbol matrix height
@@1:    Cmp ScreenMode, 0FH
        JB @@8
        Cmp Byte Ptr Lastmode[1],0H
        JNZ @@8
        CMP ScreenMode, 011H
        JB @@14
        Mov DL,16
        JMP Short @@2
@@8:    MOV DL,8
        JMP Short @@2
@@14:   MOV DL,14
@@2:    ;Calculate initial video offset
        Mov AX,0A000H
        MOV ES,AX
        MOV AL,80
        MUL Byte Ptr WINDMIN[1]
        Push dx
        mov dh,0
        mul dx
        pop dx
        XOR BX,Bx
        Mov bl,Byte Ptr WindMin
        add ax,Bx
        Mov SI,AX
        ;Calculate count of Graphic lines
        MOV AL,Byte ptr WindMax[1]
        Sub AL,Byte Ptr WindMin[1]
        Inc AL
        Mul Dl
        Mov CX,AX
        ;Calculate count of bytes per each line
        MOV Al,Byte ptr WindMax
        Sub Al,Byte Ptr WindMin
        Inc al
        CBW
        MOv bx,ax
        ;Setup EGA registers
        ;Write mode 0
        Mov Dx,3ceh
        mov al,5
        Out DX,al
        inc dx
        Mov al,0
        Out dx,al
        ;BitBlt operation - no change
        dec dx
        mov al,3
        out dx,al
        mov al,0
        inc dx
        Out dx,al
        ;Bit mask - no mask
        dec dx
        Mov al,8
        Out dx,ax
        inc dx
        mov al,0
        Out dx,ax
        ;Mov background color in Al
        Mov al,TextAttr
        Push cx
        mov cl,4
        shr al,cl
        pop cx
        cld
        mov di,si
        ;loop
@@3:    Push cx
        mov cx,bx
        Rep stosb
        add si,80
        mov di,si
        Pop cx
        Loop @@3
        Mov DX,WindMin
        Call SetCursor
        RETF

; Clear to end-of-line

ClrEol:
        CALL    GetCursor
        CMP     ScreenMode,7
        JA   @@1
        MOV     AL,TextAttr
        CALL    ScrollAttr
        MOV     BH,AL
        MOV     AX,6*256
        MOV     CX,DX
        MOV     DL,WindMax.X
        CALL    Video
        RETF
;Fill end of line in EGA/VGA graphic modes
@@1:
        MOV     AL,WindMax.X
        INC     AL
        SUB     AL,DL
        XOR     AH,AH
        PUSH AX
        CALL Fill
        RETF

; Insert line

InsLine:

        MOV     AX,7*256+1
        CALL InsDelLine
        CMP ScreenMode,7
        JBE @@1
        MOV DX,CX
        CALL FillLine
@@1:    RETF

; Delete line

DelLine:

        MOV     AX,6*256+1
        CALL InsDelLine
        CMP ScreenMode,7
        JBE @@1
        MOV DX,WindMax
        CALL FillLine
@@1:    RETF

InsDelLine:

        PUSH    AX
        CALL    GetCursor
        Mov     Al,TextAttr
        CALL    ScrollAttr
        MOV     BH,AL
        POP     AX
        MOV     CL,WindMin.X
        MOV     CH,DH
        MOV     DX,WindMax
        CMP     CH,DH
        JNE     @@1
        XOR     AL,AL
@@1:    CALL    Video
        RET

;Fill full line by spaces with current background in EGA/VGA graphic modes

FillLine: MOV DL,WindMin.X
          PUSh DX
          Call GetCursor
          MOV SI,DX
          POP DX
          Call SetCursor
          Push SI
          Push cs
          Call ClrEol
          Pop dx
          call SetCursor
          RET

; Position cursor

GotoXY:

        MOV     BX,SP
        MOV     DL,SS:[BX+6]
        MOV     DH,SS:[BX+4]
        DEC     DL
        ADD     DL,WindMin.X
        JC      @@1
        CMP     DL,WindMax.X
        JA      @@1
        DEC     DH
        ADD     DH,WindMin.Y
        JC      @@1
        CMP     DH,WindMax.Y
        JA      @@1
        CALL    SetCursor
@@1:    RETF    4

; Return cursor X coordinate

WhereX:

        CALL    GetCursor
        MOV     AL,DL
        SUB     AL,WindMin.X
        INC     AL
        RETF

; Return cursor Y coordinate

WhereY:

        CALL    GetCursor
        MOV     AL,DH
        SUB     AL,WindMin.Y
        INC     AL
        RETF

; Set text color (color modes)

TextColor:

        MOV     BX,SP
        MOV     AL,SS:[BX+4]
        TEST    AL,0F0H
        JE      @@1
        AND     AL,0FH
        OR      AL,80H
@@1:    AND     TextAttr,70H
        OR      TextAttr,AL
        RETF    2

; Set text background (color modes)

TextBackground:

        MOV     BX,SP
        MOV     AL,SS:[BX+4]
        AND     AL,7
        MOV     CL,4
        SHL     AL,CL
        AND     TextAttr,8FH
        OR      TextAttr,AL
        RETF    2

; Select low intensity

LowVideo:

        AND     TextAttr,0F7H
        RETF

; Select high intensity

HighVideo:

        OR      TextAttr,8
        RETF

; Select normal intensity

NormVideo:

        MOV     AL,NormAttr
        MOV     TextAttr,AL
        RETF

; Delay specified number of milliseconds

Delay:

        MOV     BX,SP
        MOV     DX,SS:[BX+4]
        OR      DX,DX
        JE      @@2
        MOV     AX,40H
        MOV     ES,AX
        XOR     DI,DI
        MOV     AL,ES:[DI]
@@1:    MOV     CX,DelayCnt
        CALL    DelayLoop
        DEC     DX
        JNE     @@1
@@2:    RETF    2

; Delay one timer tick or by CX iterations

DelayLoop:

@@1:    MOV     BX,4
@@2:    DEC     BX
        JNE     @@2
        CMP     AL,ES:[DI]
        LOOPE   @@1
        RET

; Start sound generator

Sound:

        MOV     BX,SP
        MOV     BX,SS:[BX+4]
        MOV     AX,34DDH
        MOV     DX,0012H
        CMP     DX,BX
        JNC     @@2
        DIV     BX
        MOV     BX,AX
        IN      AL,61H
        TEST    AL,3
        JNZ     @@1
        OR      AL,3
        OUT     61H,AL
        MOV     AL,0B6H
        OUT     43H,AL
@@1:    MOV     AL,BL
        OUT     42H,AL
        MOV     AL,BH
        OUT     42H,AL
@@2:    RETF    2

; Turn off sound generator

NoSound:

        IN      AL,61H
        AND     AL,0FCH
        OUT     61H,AL
        RETF

; Return true if key is available

KeyPressed:

        CMP     ScanCode,0
        JNE     @@1
        MOV     AH,1
        INT     16H
        MOV     AL,0
        JE      @@2
@@1:    MOV     AL,1
@@2:    RETF

; Read character from keyboard
; Out   AL = Character

ReadKey:

        MOV     AL,ScanCode
        MOV     ScanCode,0
        OR      AL,AL
        JNE     @@1
        XOR     AH,AH
        INT     16H
        OR      AL,AL
        JNE     @@1
        MOV     ScanCode,AH
        OR      AH,AH
        JNE     @@1
        MOV     AL,'C'-64
@@1:    CALL    BreakCheck
        RETF

ReadKeyWord:
        XOR     AH,AH
        MOV     ScanCode,AH
        INT     16H
        OR      AX,AX
        JNE     @@1
        MOV     AL,'C'-64
@@1:    CALL    BreakCheck
        RETF
;CRT Variables reinicialization by user request

 ReInitCrt:
         Mov AH,0FH
         CALL Video
         CMP AL,ScreenMode
         JE   @@1
         CALL CRTSetup
@@1:     RETF

; CRT file no-op procedure

CrtReturn:

        XOR     AX,AX
        RETF    4


; Get cursor position
; Out   DX = Cursor position
; Uses  AX,BX,CX,DX,ES

GetCursor:

        MOV     AH,3
        XOR     BH,BH
        JMP     Video

; Set cursor position
; In    DX = Cursor position
; Uses  AX,BX,CX,DX,ES

SetCursor:

        MOV     AH,2
        XOR     BH,BH
        JMP     Video

; Save registers and call BIOS video routine

Video:

        PUSH    SI
        PUSH    DI
        PUSH    BP
        PUSH    ES
        INT     10H
        POP     ES
        POP     BP
        POP     DI
        POP     SI
        RET

; Calculate valid attribute for fill during scrolling
ScrollAttr:
    Mov AL,TextAttr
    CMP ScreenMode,3
    JBE @@2
    CMP ScreenMode,7
    JE  @@2
    CMP ScreenMode,5
    JA  @@1
    PUSH CX
    MOV Cl,4
    SHR AL,CL
    POP CX
    AND AL,3
    XOR AH,AH
    PUSH BX
    MOV BX,AX
    MOV AL,ScrollAttrTable[BX]
    POP BX
    JMP Short @@2
@@1:XOR al,AL
@@2:Ret
;Writing char in TTY mode for Ctrl-Break Handler purposes;

WriteCrLf:MOV AL,13
          Call WriteChar
          Mov AL,10

WriteChar:MOV AH,0EH
          Mov BL,TextAttr;
          JMP Video

Beep :     MOV AX,0E07H
          CALL VIDEO
          RETF

GetPos:  CALL GetCursor
         MOV AX,DX
         RET

SetPos:  MOV BX,SP
         MOV DX,SS:[BX+2]
         CALL SetCursor
         RET 2

;Emulates cursor in graphic modes. First call shows cursor,
;Second call - hides

EmulateCursor:
         CMP  ScreenMode,4
         JB   @@3
         CMP  ScreenMode,7
         JE   @@3
         CMP  ScreenMode,6
         JE   @@1
         MOV  AX,09DBH
         MOV CX,1
         MOV BX,08FH
         CALL Video
         Jmp SHORt @@3
@@1:     Call GetCursor
         MOV AL,DH
         MOV CL,DL
         XOR AH,AH
         MOV BX,80*4
         MUL BX
         XOR CH,CH
         ADD Ax,CX
         MOV SI,AX
         MOV AX,0B800H
         PUSH ES
         MOV ES,AX
         MOV CX,4
@@2:
         NOT BYTE PTR ES:[SI]
         NOT BYTE PTR ES:[SI+8192]
         ADD SI,80
         LOOP @@2
         POP ES
@@3:     RET

;Outputs Char in any mode with correct foreground and background
WriteCh:
        MOV BX,SP
        MOV AL,SS:[BX+2]
        Cmp ScreenMode,4
        JB @@1
        CMP ScreenMode,7
        JE @@1
        CMP ScreenMode,6
        JE @@1
        MOV AH,TextAttr
        MOV CL,4
        SHR AH,CL
        PUSH AX
        MOV BL,AH
        XOR Bh,Bh
        MOV AX,09DBH
        MOV CX,1
        CAll Video
        POP AX
        MOV BL,TextAttr
        AND BL,0FH
        XOR BL,AH
        Or BL,80H
        MOV AH,9
        Call Video
        JMP Short @@2
@@1:    MOV AH,9
        MOV Bl,TextAttr
        XOR BH,BH
        MOV CX,1
        CALL Video
@@2:    Ret 2

;Fills Count Bytes by spaces with current attribute
Fill:   MOV BX,SP
        MOV CX,SS:[BX+2]
        MOV AX,0920H
        XOR BH,BH
        MOV BL,TextAttr
        CMP ScreenMode,4
        JB @@1
        CMP ScreenMode,7
        JE @@1
        CMP ScreenMode,6
        JE @@1
        MOV AL,0DBH
        Push cx
        mov cl,4
        shr bl,cl
        pop cx
   @@1: CALL Video
        RET 2

;Scrolls window up

ScrollUp:
        PUSH BP
        MOV BP,SP
        MOV CX,[BP+8]
        MOV DX,[BP+6]
        CALL ScrollAttr
        MOV BH,AL
        MOV AL,[BP+4]
        MOV AH,6
        Call Video
        POP BP
        RET 6

CODE    ENDS

        END

