unit VCrt;

{$D+,I-,S-}

interface

const

{ CRT modes }

  BW40          = 0;            { 40x25 B/W on Color Adapter }
  CO40          = 1;            { 40x25 Color on Color Adapter }
  BW80          = 2;            { 80x25 B/W on Color Adapter }
  CO80          = 3;            { 80x25 Color on Color Adapter }
  Mono          = 7;            { 80x25 on Monochrome Adapter }
  Font8x8       = 256;          { Add-in for ROM font }

{ Mode constants for 3.0 compatibility }

  C40           = CO40;
  C80           = CO80;

{ Foreground and background color constants }

  Black         = 0;
  Blue          = 1;
  Green         = 2;
  Cyan          = 3;
  Red           = 4;
  Magenta       = 5;
  Brown         = 6;
  LightGray     = 7;

{ Foreground color constants }

  DarkGray      = 8;
  LightBlue     = 9;
  LightGreen    = 10;
  LightCyan     = 11;
  LightRed      = 12;
  LightMagenta  = 13;
  Yellow        = 14;
  White         = 15;

{ Add-in for blinking }

  Blink         = 128;

var

{ Interface variables }

  CheckBreak: Boolean;    { Enable Ctrl-Break }
  CheckEOF: Boolean;      { Enable Ctrl-Z }
  DirectVideo: Boolean;   { Enable direct video addressing }
  CheckSnow: Boolean;     { Enable snow filtering }
  LastMode: Word;         { Current text mode }
  TextAttr: Byte;         { Current text attribute }
  WindMin: Word;          { Window upper left coordinates }
  WindMax: Word;          { Window lower right coordinates }
  ScreenMode: Byte;       { Actual screen mode, may be graphic}
{ Interface procedures }

procedure AssignCrt(var F: Text);
function KeyPressed: Boolean;
function ReadKey: Char;
function ReadKeyWord:Word ;
procedure TextMode(Mode: Integer);
procedure ReInitCrt;
procedure Window(X1,Y1,X2,Y2: Byte);
procedure GotoXY(X,Y: Byte);
function WhereX: Byte;
function WhereY: Byte;
procedure ClrScr;
procedure ClrEol;
procedure InsLine;
procedure DelLine;
procedure TextColor(Color: Byte);
procedure TextBackground(Color: Byte);
procedure LowVideo;
procedure HighVideo;
procedure NormVideo;
procedure Delay(MS: Word);
procedure Sound(Hz: Word);
procedure NoSound;
procedure Beep;

implementation
uses DOS;
{$L VCRT.OBJ}
Const ScrollAttrTable:Array [0..3]of byte = (0,$55,$AA,$FF);
procedure Initialize; external;
function KeyPressed; external;
function ReadKey; external;
function ReadKeyWord;external;
procedure TextMode; external;
procedure ReInitCRT; external;
procedure Window; external;
procedure GotoXY; external;
function WhereX; external;
function WhereY; external;
procedure ClrScr; external;
procedure ClrEol; external;
procedure InsLine; external;
procedure DelLine; external;
procedure TextColor; external;
procedure TextBackground; external;
procedure LowVideo; external;
procedure HighVideo; external;
procedure NormVideo; external;
procedure Delay; external;
procedure Sound; external;
procedure NoSound; external;
function GetPos:word; external;
Procedure SetPos(Pos:Word);External;
Procedure WriteCH(CH:Char);External;
Procedure ScrollUp(Min,Max:Word;Lines:byte);External;
Procedure EmulateCursor; external;
Procedure Fill(Count:Word);external;
Procedure Beep;external;
{$F+}
Function CRTReturn(var F:TextRec):word;external;
{$F-}

Procedure WriteChar(ch:Char;OutAll:Boolean);
var
    Pos:Word;A:Byte;
Procedure TestPos;
var FF:Boolean;
begin
 FF:=False;
 if Lo(Pos)>Lo(WindMax) then
  begin
   Inc(Pos,$100);
   Pos:=Pos and $FF00 or Lo(WindMin);
  end;
    if Hi(Pos)>HI(WindMax) then begin
    ScrollUp(WindMin,WindMax,1);
    FF:=ScreenMode>7;
    Pos:=WindMax and $FF00 or Lo(WindMin);
   end;
 SetPos(Pos);
 if FF then Fill(Lo(WindMax)-Lo(WindMin)+1);
end;
{Procedure WriteCh(ch:Char);
var A:Byte;
begin
  if (Mode<4)or(Mode=6)or(Mode=7) then
  OutChar(ch,TextAttr)
   else
    begin
     A:=TextAttr shr 4;
     OutChar(#219,A);
     OutChar(ch,((TextAttr and $F)xor A) or $80);
    end;
  inc(Pos);
end;}
Begin
 Pos:=GetPos;
 TestPos;
 if OutAll then begin WriteCh(CH);Inc(Pos) end
 else
 case ch of
 #7:Beep;
 #8:if Lo(Pos)>Lo(WindMin) then
    Dec(Pos);
 #9:begin
     A:=Lo(Pos);
     Pos:=Pos and $FF00 or (Lo(Pos)+7) and $f8;
     if Lo(Pos)>Lo(WindMax) then Pos:=Pos and $FF00 or Succ(Lo(WindMax));
     Fill(Lo(Pos)-A);
    end;
 #10: inc(pos,$100);
 #13: Pos:=Pos and $FF00+Lo(WindMin);
 else
  WriteCh(ch);
  Inc(Pos);
 end;
 TestPos;
end;
{$F+}
Function ScrWrite(var F:TextRec):word;
var I:Integer;
begin
 ReInitCrt;
 if F.BufPos<>F.BufEnd then
 For i:=0 to Pred(F.BufPos) do
  WriteChar(F.BufPtr^[i],False);
 ScrWrite:=0;
 F.BufPos:=0;
end;
Function ScrRead(var F:TextRec):word;
var Pos:Integer;
    CsrPos:Word;
    Key:Word;
    S:String;
Procedure Locate;
begin
 SetPos(CsrPos + Pos );
end;
Procedure WriteRest;
var i:Integer;
begin
 For i:=Succ(Pos) to Length(s) do
  WriteChar(S[i],True);
  Locate;
end;
Procedure DelCh;
begin
 Delete(S,Succ(Pos),1);
 S[Succ(Length(S))]:=' ';
 inc(S[0]);
 WriteRest;
 dec(S[0]);
end;
Procedure Left;
begin
 Dec(Pos);
 Locate;
end;
Procedure Home;
begin
 Pos:=0;
 Locate;
end;
begin
 ReInitCRT;
 Pos:=0;S:='';
 CsrPos:=GetPos;
 Repeat
  EmulateCursor;
  Key:=ReadKeyWord;
  EMulateCursor;
   Case Key of
   $0E08:if Pos>0 then begin Left;DelCh end;
   $11b:begin Home;Fill(Length(S));S:='' end;
   $4700:Home;
   $4b00:if Pos>0 then Left;
   $4D00:if Pos<Length(S) then begin inc(Pos);Locate end;
   $4F00:begin Pos:=Length(S);Locate end;
   $5300:if Pos<Length(S) then DelCH;
   $1C0D:;
   else
    if (Lo(CsrPos)+Pos<=Lo(WindMax))and(Pos<F.BufSize-2)and((Lo(Key)<>0) or (hi(Key)=3)) then
     begin
      Inc(Pos);
      Insert(chr(lo(key)),S,Pos);
      Dec(Pos);
      WriteRest;
      Inc(Pos);
      Locate;
     end;
   end;
  until  Key=$1C0D;
  S:=S+#13#10;
  Move(S[1],F.BufPtr^,Length(S));
  ScrRead:=0;
  F.BufPos:=0;
  F.BufEnd:=Length(S);
    WriteChar(#13,False);
    WriteChar(#10,False);
end;
Function ScrOpen(var F:TextRec):word;
begin
 if F.Mode=fmInput then
  begin
   F.InOutFunc:=@ScrRead;
   F.FlushFunc:=@CRTReturn;
  end
   else
  begin
   F.Mode:=fmOutPut;
   F.InOutFunc:=@ScrWrite;
   F.FLushFunc:=@ScrWrite;
  end;
 F.Name[0]:=#0;
 F.CloseFunc:=@CRTReturn;
 ScrOpen:=0;
end;
{$F-}
Procedure AssignCRT(var F:Text);
var FF:TextRec absolute F;
begin
 FF.Mode:=fmClosed ;
 FF.OpenFunc:=@ScrOpen;
end;
begin
  Initialize;
  AssignCrt(Input); Reset(Input);
  AssignCrt(Output); Rewrite(Output);
end.

